<?php
/*
Plugin Name: 123 Comment Approve Blogroll
Plugin URI: http://schnurpsel.de/die-gute-alte-blogrolle-1426/
Description: Trackbacks und Pingbacks von Seiten, die in der Blogrolle (Linkliste) stehen, immer erlauben
Author: Schnurpsel (Ingo Henze)
Version: 0.10
Author URI: http://putzlowitsch.de/
*/ 

if( !defined( 'PLW123COM_APP_BLO' ) ) :
// Einstellungen

// true - immer erlauben
// false - nur erlauben, wenn Option 'Der Autor muss bereits einen genehmigten Kommentar geschrieben haben.' aktiv ist
define( 'PLW123COM_APP_BLO', false );

// Funktionen
function plw123cab_pre_comment_approved( $approved, $commentdata ) {
	global $wpdb;
	extract( $commentdata, EXTR_SKIP );

	// Blogrolle prfen?
	if( 1 == get_option( 'comment_whitelist' ) || PLW123COM_APP_BLO ) {
		if ( 'trackback' == $comment_type || 'pingback' == $comment_type ) { // Trackback oder Pingback?
			$uri = @parse_url( $comment_author_url );
			$domain = $uri['host'];
			$domain_ips = gethostbynamel( $domain );
			if( is_array( $domain_ips ) )
				if( in_array( $comment_author_IP, $domain_ips ) ) // pat die Domain zur sendenden IP-Adresse?
					if( $wpdb->get_var( $wpdb->prepare( "SELECT link_id FROM $wpdb->links WHERE link_url LIKE (%s) LIMIT 1", '%'.$domain.'%') ) )
						$approved = 1;
		}		
	}
	
	return $approved;
}
add_filter( 'pre_comment_approved', 'plw123cab_pre_comment_approved', 10, 2 );

endif;
?>